
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[javaSE] 多线程通信（等待-唤醒机制） / 憋错料</title>

    <meta name="description" content="[javaSE] 多线程通信（等待-唤醒机制） 两个线程操作同一个资源,比如,输入和输出,操作同一个对象,此时两个线程会争夺cpu的执行权,随机的进行切换.我们想实现先输入再输出,顺序的执行 目标对象定义一个标记字段,进行判断,wait()和notify()方法 wait()方法,线程会处于等待状态,等待的线程位于内存中的线程池中 notify()方法,唤醒线程池中的线程 notifyAll()方法,唤醒全部线程 上面的方法,需要写在同步里面,并且需要标识锁 这些操作线程的方法定义在Object对象中,因为这些方法,要通过同一个锁对象来调用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[javaSE] 多线程通信（等待-唤醒机制）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>两个线程操作同一个资源，比如，输入和输出，操作同一个对象，此时两个线程会争夺cpu的执行权，随机的进行切换。我们想实现先输入再输出，顺序的执行</p>
<p>目标对象定义一个标记字段，进行判断，wait()和notify()方法</p>
<p>wait()方法，线程会处于等待状态，等待的线程位于内存中的线程池中</p>
<p>notify()方法，唤醒线程池中的线程</p>
<p>notifyAll()方法，唤醒全部线程</p>
<p>上面的方法，需要写在同步里面，并且需要标识锁</p>
<p>这些操作线程的方法定义在Object对象中，因为这些方法，要通过同一个锁对象来调用</p>
<pre>/**
 * 资源
 *
 * @author taoshihan
 *
 */
class People {
    String name;
    String sex;
    Boolean myLock = false;
}

/**
 * 输入
 *
 * @author taoshihan
 *
 */
class PeopleJoin implements Runnable {
    private People resource;

    public PeopleJoin(People resource) {
        this.resource = resource;
    }

    @Override
    public void run() {
        // 切换
        boolean flag = true;
        while (true) {
            synchronized (resource) {
                if (resource.myLock) {
                    try {
                        resource.wait();
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
                if (flag) {
                    resource.name = "taoshihan";
                    resource.sex = "nan";
                } else {
                    resource.name = "陶士涵";
                    resource.sex = "男";
                }
                flag = !flag;
                resource.myLock=true;
                resource.notify();
            }
        }
    }

}

/**
 * 输出
 *
 * @author taoshihan
 *
 */
class PeopleOut implements Runnable {
    private People resource;

    public PeopleOut(People resource) {
        this.resource = resource;
    }

    @Override
    public void run() {
        while (true) {
            synchronized (resource) {
                if(!resource.myLock){
                    try {
                        resource.wait();
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
                System.out.println(resource.name + "=====" + resource.sex);
                resource.myLock=false;
                resource.notify();
            }
        }
    }

}

public class ThreadDemo {

    /**
     * @param args
     */
    public static void main(String[] args) {
        People resource = new People();
        PeopleJoin input = new PeopleJoin(resource);
        PeopleOut output = new PeopleOut(resource);

        Thread t1 = new Thread(input);
        Thread t2 = new Thread(output);
        t1.start();
        t2.start();
    }

}</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzcyNjI1NC8yMDE2MDYvNzI2MjU0LTIwMTYwNjA2MjM1MzE2OTE4LTEwNjg0NjUzNjcuanBn.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-13 08:52:02 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[javaSE] 多线程通信（等待-唤醒机制）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQ72B3.html" rel="bookmark">java基础知识回顾之java Thread类学习（八）--java多线程通信等待唤醒机制经典应用（生产者消费者）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 *java多线程--等待唤醒机制:经典的体现&quot;生产者和消费者模型 *对于此模型,应该明确以下几点: *1.生产者仅仅在仓库未满的时候生产,仓库满了则停止生产. *2.消费者仅仅在有产品的时候才能消费,仓空则等待. *3.当消费者发现仓储没有产品可消费的时候,会唤醒等待生产者生产. *4.生产者在生产出可以消费的产品的时候,应该通知等待的消费者去消费. 下面先介绍个简单的生产者消费者例子:本例只适用于两个线程,一个线程生产,一个线程负责消费. 生产一个资源,就得消费一个资源. 代码如下: pub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGGV2bM.html" rel="bookmark">java基础知识回顾之java Thread类学习（七）--java多线程通信等待唤醒机制（wait和notify&comma;notifyAll）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.wait和notify,notifyAll: wait和notify,notifyAll是Object类方法,因为等待和唤醒必须是同一个锁,不可以对不同锁中的线程进行唤醒,而锁可以是任意对象,所以可以被任意对象调用的方法,定义在Object基类中. wait()方法:对此对象调用wait方法导致本线程放弃对象锁,让线程处于冻结状态,进入等待线程的线程池当中.wait是指已经进入同步锁的线程,让自己暂时让出同步锁,以便使其他正在等待此锁的线程可以进入同步锁并运行,只有其它线程调用notify方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MylBJa4.html" rel="bookmark">java多线程的等待唤醒机制及如何解决同步过程中的安全问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/* class Person{ String name; String sex; boolean flag = true; public void setPerson(String name, String sex){ this.sex=sex; this.name=name; } } class Input implements Runnable{ int x=0; Person p; Input(Person p){ this.p=p; } public void run(){ while			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDg9le4.html" rel="bookmark">线程间通信&mdash;&mdash;等待唤醒机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				线程间通信——等待唤醒机制,避免争夺同一资源: 锁对象可以是任意Object类的子类对象: 包子案例: 包子案例——生产者和消费者: 代码实现: 关键就是在于两个线程使用同一个锁对象! 这边是主程序调用这两个线程时候传入的同一个对象! 包子铺线程类——生产者: 其中,baozi类作为成员变量,并且重载了带参的构造方法: 锁对象为调用包子铺带参的构造方法传入的这个包子变量bz; 调用点wait方法必须是锁对象调用,锁对象调用wait方法之后当前线程就进入等待状态,另外一个线程此时应该是正在执行:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KAv5w4.html" rel="bookmark">线程间的通信--等待唤醒机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.多个线程操作相同的资源,但是操作动作不同,所以存在安全问题例如: public class Test { public static void main(String[] args) { Resource r = new Resource(); Input in = new Input(r); Output out = new Output(r); Thread tin = new Thread(in); Thread tout = new Thread(out); tin.start();			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n3Z5mG0.html" rel="bookmark">java 22 - 17 多线程之等待唤醒机制（接16）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先来一张图,看看什么叫做等待唤醒机制 接上一章的例子. 例子:学生信息的录入和获取 * 资源类:Student  * 设置学生数据:SetThread(生产者) * 获取学生数据:GetThread(消费者) * 测试类:StudentDemo * 资源类:Student (为了使用等待唤醒机制,添加了个布尔类型的变量,默认为flase) 1 public class Student { 2 String name; 3 int age; 4 boolean flag; // 默认情况是没有数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgDbYR0.html" rel="bookmark">JAVA-初步认识-第十四章-线程间通信-等待唤醒机制-代码优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 上一节中的代码写的并不是很眼镜,如下图中的属性,应该都是私有的.我们不应该直接访问资源中的属性,是因为它具备了不安全性. 瞎赋值怎么办呢?为了可控,意味着资源里面的属性需要被私有化,并对外提供方法访问.因此上节中的代码要进行改写. 首先对资源描述类进行修改,至于为什么set方法中写有两个形参,是因为name和sex同时要做赋值,因此直接将它们定义在一起. 而且类中提供了直接输出name和sex的方法,后面的程序中就不需要写那么长的输出语句了.这个输出问题比较简单 关键问题在哪儿呢?如果这么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47B9O13.html" rel="bookmark">多线程的等待唤醒机制之消费者和生产者模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/** * 等待唤醒之生产者和消费者模型 * 生成者: 创建和添加数据的线程 * 消费者: 销毁和删除数据的线程 * 问题1: 生成者生成数据过快, 消费者消费数据相对慢,不接收数据了, 会造成数据丢失 * 问题2: 消费者消费数据过快, 生成者生成数据相对慢,不发送数据了, 会造成数据被重复读取 * 总结 : 生产数据过快会造成数据丢失 * 生成数据过慢会造成数据被重复读取 * * * wait()和notifyAll()用法: * 1. 必须是同一个对象的wait()和和notifyAll(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMg26n4.html" rel="bookmark">多线程等待唤醒机制之生产消费者模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上篇楼主说明了多线程中死锁产生的原因并抛出问题--死锁的解放方案,那么在本篇文章,楼主将引用一个KFC生产汉堡,顾客购买汉堡的过程来说明死锁解决方案及多线程的等待唤醒机制. 简单地用一幅图来说明KFC生产汉堡,顾客来消费的过程: 场景分析: 资源类:Hamburger 设置汉堡数据:SetThread(生产者) 获取汉堡数据:GetThread(消费者) 测试类:HamburgerTest 不同种类的线程(生产者.消费者)针对同一资源(汉堡)的操作 当汉堡有存货的时候,汉堡师傅不再生产,顾客可消			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoQnbw3.html" rel="bookmark">Java---18---多线程：等待唤醒机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				class Res { String name; String sex; } class Input implements Runnable { private Res r; public Input(Res r) { // TODO Auto-generated constructor stub this.r = r; } public void run() { int x = 0; while (true) { synchronized (r) { if (x == 0) { r.name			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMymPpM.html" rel="bookmark" class="title">POST对URL中末尾斜杠的差异</a>
					<div>
						在调试一个接口,php的,文件名是index.php,放在目录/checkmail/下. 访问时的url写的是/checkmail,调用时用的是JQuery的post方法. 开始发现,被调用时检查传入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmKVB3.html" rel="bookmark" class="title">js中const&comma;var&comma;let区别</a>
					<div>
						今天面试,被问了个问题,const, var, let的区别,当时就懵圈了,var 知道,const.let 是什么鬼??? 回来一百度,找到一篇通俗易懂的介绍,先取之收藏,以备忘.主要内容是:js中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3ZE2L0.html" rel="bookmark" class="title">利用border和border-radius绘制一些小图片</a>
					<div>
						大都知道border属性有四个参数,那么border-radius必然也是有四个参数 我们知道border属性的四个参数分别是border-top,border-right,border-bottom ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949aOW4.html" rel="bookmark" class="title">算法学习</a>
					<div>
						决策树是一种树状结构,它的每一个叶节点对应一个分类,非叶节点对应在某个属性上的划分,根据样本在该属性上的不同取值将其划分为若干子集.构造决策树的核心问题是在每一步如何选择适当的属性对样本进行划分. I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n1B1KM.html" rel="bookmark" class="title">MIT墙上的格言（如果你把任务留到最后一分钟，那么你一定能在一分钟内完成任务）</a>
					<div>
						1,永远不能忘记傅立叶变换. Never far no can forget Fuliye changer. 2,盲目的研究者就像法拉第和麦克斯韦之间的电学家一样无所适从. Blind Eye's r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8Kaz0.html" rel="bookmark" class="title">linux中shell变量&dollar;&num;&comma;&lbrack;email&amp;&num;160&semi;protected&rsqb;&comma;&dollar;0&comma;&dollar;1&comma;&dollar;2的含义解释</a>
					<div>
						摘抄自:ABS_GUIDE 下载地址:http://www.tldp.org/LDP/abs/abs-guide.pdf linux中shell变量$#,[email protected],$0,$1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2YRq3.html" rel="bookmark" class="title">android下载地址</a>
					<div>
						http://blog.csdn.net/tiandiren2007/article/details/49737225 http://history.zwbk.org/ NDK http://www. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdoAmM.html" rel="bookmark" class="title">iOS开发之网络图片缓存</a>
					<div>
						问题一:如果使用同步下载,那么网速慢的时候会超级卡 问题二:图片没有frame,所以cell初始化的时候,给imageView的frame是0,异步下载完成之后不显示 解决办法:使用占位图(如果占位图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aDdmqM.html" rel="bookmark" class="title">获取键盘charCode函数</a>
					<div>
						window.onload = function(){ document.onkeypress = function(evt){ alert(String.fromCharCode(getCharCo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8j1V0.html" rel="bookmark" class="title">codevs：1313 质因数分解：已知正整数 n是两个不同的质数的乘积，试求出较大的那个质数 。</a>
					<div>
						#include&lt;iostream&gt;#include&lt;cstdio&gt;#include&lt;cmath&gt;using namespace std;int a[2];int  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BlzqM.html" rel="bookmark" class="title">第二十四天到二十六天学习笔记</a>
					<div>
						八号这天,主要先是学习了数组对象 1 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElJJx4.html" rel="bookmark" class="title">Linux 相关目录介绍</a>
					<div>
						学习Linux,首先了解Linux标准目录结构很重要的,对以后的学习有很好的铺垫作用.本文不会去罗列大而全的全部目录.本文主要说明,笔者本人接触,需要了解的一些文件目录,当然本文也会不断的更新或更改. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1p7P3.html" rel="bookmark" class="title">站点搭建从零開始（七） WordPress站点的完好</a>
					<div>
						1.WordPress站点前后端经常使用语言简单介绍和执行过程 通常一个站点的整个构建过程中须要大量的技术支持,尤其是用到非常多种计算机语言.站点的构建主要分后端和前端两部分,后端代码在server上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MooyJlM.html" rel="bookmark" class="title">GridView规则显示图片</a>
					<div>
						首先是自定义的GridVIew,ListView嵌套GridVIew时必须自定义GridVIew,不嵌套时可以不用.这里的GridView会根据图片多少自动调节大小 //自定义的GridView ,以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQOO83.html" rel="bookmark" class="title">用SAX和PULL进行XML文件的解析与生成</a>
					<div>
						XML解析有传统的dom方法还有Jsoup,SAX,PULL等,这里讲的是比较省内存的SAX和PULL方法.Android中极力推荐用PULL的方式来解析,我个人觉得pull确实比较简单,但其内部的逻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGYaK3.html" rel="bookmark" class="title">浏览器工作原理学习记录</a>
					<div>
						浏览器是我们前端开发者工作的平台,是我们最长用的软件,是我们必须要了解的知识面,做个学习记录. 现在人都离不开网络,在网上我们能干很多事情,用途最多的就是浏览器,它是一扇窗户,打开这扇窗户可以看到大千 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MowLExM.html" rel="bookmark" class="title">&lbrack;Vijos1617&rsqb; 超级教主（DP &plus; 单调队列）</a>
					<div>
						传送门 设 f[i] 表示吃完 f[i] 及其以下的能量球后所剩下的能量. 所以 f[i] = max(f[i], f[j] + (sum[i] - sum[j]) - i * 100) ( 0 &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kw67P0.html" rel="bookmark" class="title">kvm虚拟机--存储池配置梳理&lpar;转&rpar;</a>
					<div>
						1.创建基于文件夹的存储池(目录) 2.定义存储池与其目录 1 # virsh pool-define-as vmdisk --type dir --target /data/vmfs 3.创建已定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyDkQm4.html" rel="bookmark" class="title">01---4中过滤器的总结与使用</a>
					<div>
						1.过滤器的使用(创建一个MyFilter文件夹存储所有的过滤器) 1.1 Authorization 1.1.1创建一个MyAuthorization继承自AuthorizatioAttribute ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qDAnG0.html" rel="bookmark" class="title">Java进阶学习第六天&mdash;&mdash;DOM4J入门</a>
					<div>
						文档版本 开发工具 测试平台 工程名字 日期 作者 备注 V1.0 2016.04.17 lutianfei none XML约束--schema XML Schema 也是一种用于定义和描述 XML ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
